#include <stdio.h>

#ifndef PARSER_H
#define PARSER_H
struct SyntaxElement* se_init(void);
struct SyntaxElement* se_bottom(struct SyntaxElement* syntaxelement);
struct SyntaxElement* se_next(struct SyntaxElement* syntaxelement);
void se_free(struct SyntaxElement* syntaxtree);

enum SyntaxElementType {
	TOPTREE,
	TREE,
	TOKEN,
	STRING,
	NUMBER,
	NONE
};

struct SyntaxElement {
	enum SyntaxElementType type;
	void* content;
	struct SyntaxElement* next;
	struct SyntaxElement* top;
};

struct SyntaxElement* parse(FILE* file);
#endif
